



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Using Run-Time Dynamic Linking（使用运行时动态链接库）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Using Run-Time Dynamic Linking（使用运行时动态链接库）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 18:14:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">// A simple program that uses LoadLibrary and // GetProcAddress to access myPuts from Myputs.dll.<br />
#include &lt;windows.h&gt;<br />
#include &lt;stdio.h&gt; 

typedef int (__cdecl *MYPROC)(LPWSTR); 

int main( void )<br />
{<br />
    HINSTANCE hinstLib;<br />
    MYPROC ProcAdd;<br />
    BOOL fFreeResult, fRunTimeLinkSuccess = FALSE; 

    // Get a handle to the DLL module.

    hinstLib = LoadLibrary(TEXT("MyPuts.dll")); 

    // If the handle is valid, try to get the function address.

    if (hinstLib != NULL)<br />
    {<br />
        ProcAdd = (MYPROC) GetProcAddress(hinstLib, "myPuts"); 

        // If the function address is valid, call the function.

        if (NULL != ProcAdd)<br />
        {<br />
            fRunTimeLinkSuccess = TRUE;<br />
            (ProcAdd) (L"Message sent to the DLL function\n");<br />
        }<br />
        // Free the DLL module.

        fFreeResult = FreeLibrary(hinstLib);<br />
    } 

    // If unable to call the DLL function, use an alternative.<br />
    if (! fRunTimeLinkSuccess)<br />
        printf("Message printed from executable\n"); 

    return ;

}</pre>
</div>
<div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<hr /></div>
<div>&nbsp;</div>
<div>int&nbsp;(__cdecl&nbsp;*MYPROC)(LPWSTR);</p>
<p>int&nbsp;表示函数的返回值为&nbsp;int &nbsp; &nbsp; 若是&nbsp;TLSConnectToLsServer&nbsp;函数，则应为&nbsp;TLS_HANDLE</p></div>
<div>(__cdecl&nbsp;*MYPROC)&nbsp;说明这是一个函数指针，调用方式为&nbsp;__cdecl （还有_stdcall）</div>
<div>LPWSTR&nbsp;说明此函数有一个参数，类型为&nbsp;LPWSTR</p>
<div></p>
<div>(函数指针语法就是要求这样定义的，不是为什么要用，而是必须要用)</div>
<div>&nbsp;</div>
<div>
<hr /></div>
<div>
<div>
<pre class="prettyprint linenums">使用LoadLibrary把dll文件load进内存，使用GetProcAddress得到函数地址就可以使用了 
</pre>
<hr />
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;windows.h&gt;<br />
#include &lt;string&gt;<br />
#include &lt;iostream&gt; 

using namespace std;<br />
void main(void)<br />
{<br />
        typedef int (__stdcall   *PFUNCTION)( int k,int i);<br />
        //声明参数类型，以后会用到PFUNCTION<br />
        HMODULE hLib = ::LoadLibrary("xx.dll");<br />
        if ( NULL == hLib )<br />
        {<br />
                perror("装载DLL文件错误:");<br />
        }<br />
        else<br />
        {

                PFUNCTION myAddFunction=myAddFunction=(PFUNCTION)::GetProcAddress(hLib,"ConnectEx");//ConnectEx是动态库中的方法<br />
                if ( NULL == myAddFunction)<br />
                {<br />
                        perror("装载的DLL文件中无对应的函数:");<br />
                }<br />
                else<br />
                {<br />
                        int k=myAddFunction(,);<br />
                        cout &lt;&lt;k &lt;&lt;endl;<br />
                }<br />
                ::FreeLibrary(hLib);<br />
        }<br />
}</pre>
</div>
</div>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jmvkl9.html">java实现批量下载百度图片搜索到的图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kr016q.html">SqlServer与MySql的一些常用用法的差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8krmp5q.html">Java面试题技术类一</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r25prq.html">Hadoop伪分布式配置&colon;CentOS6&period;5&lpar;64&rpar;&plus;JDK1&period;7&plus;hadoop2&period;7&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykw429.html">Android相关sdk使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3z7jq.html">Mybatis在xml文件中处理大于号小于号的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1nd48.html">android 登陆案例&lowbar;sd卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdelggj9.html">&commat;DataProvider  ITestContext 参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v3egn8.html">3Sum Closest&mdash;&mdash;LeetCode</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15loyq.html">在Delphi中开发使用多显示器的应用程序（MonitorCount和DefaultMonitor）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zx4mg9.html">oracle exp实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdd6x9.html">Python面向对象编程（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zd5x39.html">java中方法调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk42gz8.html">某pdf转word v6&period;3&period;0&period;2算法分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd443z9.html">Vue&period;js-03：第三章 - 事件修饰符的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj37xz8.html">&num;Java学习之路&mdash;&mdash;基础阶段（第四篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250peoq.html">yii2上传七牛图片&lpar;超详细&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4m778.html">java 之2D过气游戏类的写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv7dr28.html">BindingFlags 枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv63zz8.html">关于C&plus;&plus;中字符串与数字的互相转换</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0gvveq.html">&commat;DataProvider Method 参数传递</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0gvw4q.html">sr4000自带API和opencv结合获取图像</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnz60pq.html">高性能以太网芯片W5500 数据手册 V1&period;0（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e126zm9.html">学习并使用了两种linq to entity 的实现sql关键字in的查询方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okorn59.html">oc学习之路----QQ聊天界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnxgkz8.html">一个疑难bug的解决过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z26y09.html">Unrecognized Windows Sockets error&colon; 0&colon; JVM&lowbar;Bind 异常解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydx7jxq.html">js返回上一页方法区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vl36o8.html">android学习二（Activity）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wv4dlq.html">TransactionScope 对该事务的状态无效 和一些注意事项</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
